
/*
  'a' will equal the maximum number of decimal places necessary to
  represent a base 'baseIN' number with 'n' fraction digits when converted
  to base 'baseOUT'.
*/
var baseIN = 2;
var baseOUT = 10;
var n = 8;

for ( ;  baseIN < 65; baseIN++ ) {

var a = ( function ( m, n ) {
    var e, f, q,
        i = 2,
        d = 0;

    for ( ; m > 1 && n > 1; i++ ) {
        e = f = 0;

        while ( m % i == 0 ) {
            e++;
            m /= i;
        }

        while ( n % i == 0 ) {
            f++;
            n /= i;
        }

        // if i is a prime factor of both m and n
        if ( e && f ) {
            q = e / f;

            if ( q > d ) {
                // d = ceil of q
                d = q == ( q | 0 ) ? q : q + 1 | 0;
            }
        }
    }

    return d
})( baseIN, baseOUT ) * 1;

if ( a > 1 ) {
    console.log('baseIN ' + baseIN + '  \t' + a + ', ');
}    
}

/*
baseOUT variable
baseIN 10: 1 if divisble by 2 or 5


----------------
baseIN variable

baseOUT 8: 1 if baseIN is not odd, 2 if baseIN is divisibleby 8, although 8 itself is 1.
baseOUT 16: 1 if baseIN is not odd, 2 if baseIN is 32 or 64.
baseOUT 64: 1 if baseIN is not odd.


// baseOUT = 2, 10;
// baseIN: 
{
2 :     1,
4 :     2,
5 :     1,
6 :     1,
8 :     3,
10:     1,
12:     2,
14:     1,
15:     1,
16:     4,
18:     1,
20:     2,
22:     1,
24:     3,
25:     2,
26:     1,
28:     2,
30:     1,
32:     5,
34:     1,
35:     1,
36:     2,
38:     1,
40:     3,
42:     1,
44:     2,
45:     1,
46:     1,
48:     4,
50:     2,
52:     2,
54:     1,
55:     1,
56:     3,
58:     1,
60:     2,
62:     1,
64:     6
}
*/