/*
 * This is a JavaScript Scratchpad.
 *
 * Enter some JavaScript, then Right Click or choose from the Execute Menu:
 * 1. Run to evaluate the selected text (Ctrl+R),
 * 2. Inspect to bring up an Object Inspector on the result (Ctrl+I), or,
 * 3. Display to insert the result in a comment after the selection. (Ctrl+L)
 */

function full(n) {
    var s = '';
    while ( s.length < n ) {
        s += Math.random().toString().slice(2);
    }
    s = s.slice( 0, n ).split('');

    for (var i = 0; i < s.length; i++ ) {
        s[i] = +s[i];
    }
    return s;
}

function digit(n) {
    var s = new Array(n);
    for (var i = 0; i < n; i++ ) {
        s[i] = Math.random() * 10 | 0;
    }
    return s;
}


var start = new Date();

for ( var i = 0; i < 1e2; i++ ) {
    //console.log( full(10)+'' );
    //console.log( digit(10)+'' );
    //digit(1000);
    console.log( getRandBrowser4(9)  );
    //getRandBrowser3(10);
    //full(1000);
}
console.log( 'Time taken: ' +  ( (new Date()) - start ) + ' ms' );


/*
// node
try {
    var rb = require('crypto').randomBytes;
} catch (e) {}

// alternative
if ( crypto && crypto.randomBytes ) {
var rb = require('crypto').randomBytes;

rb(5); // returns an array of five random bytes
rb(1)[0]; // returns a number between 0 and 255 inclusive
// rb(8).readDoubleBE(0)
*/

// 1e6 in 7300/9500 ms
function getRandBrowser(one) {
    var n;

    if (one) {

        // Probability of repetition = 6 / 256 = 0.023 (i.e. 1 in 42.7).
        do {
            n = crypto.getRandomValues( new Uint8Array(1) )[0];
        } while ( n > 249 );
        n = n % 10 + '';
    } else {

        // Probability of repetition = 294967297 / 4294967296 =~ 0.0687 (i.e. 1 in 14.6).
        do {
            // 0 >= n < 4294967296
            n = crypto.getRandomValues( new Uint32Array(1) )[0];
        } while ( n >= 4e9 );
        // Add 1e9 so 1000000000 >= n <= 4999999999 and omit leading digit.
        n = ( n + 1e9 ).toString().slice(1);
    }

    return n;
}

function getRandBrowser2(str) {
    var n;

    // Probability of repetition = 294967297 / 4294967296 =~ 0.0687 (i.e. 1 in 14.6).
    do {
        // 0 >= n < 4294967296
        n = crypto.getRandomValues( new Uint32Array(1) )[0];
    } while ( n >= 4e9 );
    // Add 1e9 so 1000000000 >= n <= 4999999999 and omit leading digit.
    n = ( n + 1e9 ).toString().slice(1);

    return str ? n : +( '0.' + n );
}

function getRandBrowser3(max) {
    var n, limit, str;

    if (max) {
        limit = ( 256 / max | 0 ) * max - 1;

        // Probability of second iteration if max is 10 = 6 / 256 = 0.023 (i.e. 1 in 42.7).
        do {
            n = crypto.getRandomValues( new Uint8Array(1) )[0];
        } while ( n > limit );
        str = n % max + '';
    } else {

        // Probability of second iteration = 294967297 / 4294967296 =~ 0.0687 (i.e. 1 in 14.6).
        do {
            // 0 >= n < 4294967296
            n = crypto.getRandomValues( new Uint32Array(1) )[0];
        } while ( n >= 4e9 );
        // Add 1e9 so 1000000000 >= n <= 4999999999 and omit leading digit.
        str = ( n + 1e9 + '' ).slice(1);
    }

    return str;
}

function getRandBrowser4(max) {
    var n;

    return max ? ( n = crypto.getRandomValues( new Uint8Array(1) )[0],
        n > ( 256 / max | 0 ) * max - 1 ? getRandBrowser4(max) : n % max + '' ) :
      ( n = crypto.getRandomValues( new Uint32Array(1) )[0],
        n >= 4e9 ? getRandBrowser4(max) : ( n + 1e9 + '' ).slice(1) );   
}













function nextRandomDigit() {
    var n;
    var i = 0;
    var arr = crypto.getRandomValues(new Uint8Array(4));

    do {
        n = arr[i++];
    } while ( n > 249 )

    return n >= 0 ? n * 0.04 | 0 : nextRandomDigit();
}

// Returns a random digit from 0 to 9 inclusive.
function nextDigit() {
    var n = crypto.getRandomValues(new Uint8Array(1))[0];
    return n < 250 ? n * 0.04 | 0 : nextDigit();
}


function smext() {
    for ( var i = 0; i < 250; i++ ) {
        var j = i * 0.04 | 0;
        console.log( j.toString() );
    }

}



// http://stackoverflow.com/questions/18230217/javascript-generate-a-random-number-within-a-range-using-crypto-getrandomvalues?rq=1
function getRandomInt(min, max) {
    // Create byte array and fill with 1 random number
    var byteArray = new Uint8Array(1);
    window.crypto.getRandomValues(byteArray);

    var range = max - min + 1;
    var max_range = 256;
    if (byteArray[0] >= Math.floor(max_range / range) * range)
        return getRandomInt(min, max);
    return min + (byteArray[0] % range);
}

